import requests
import json
import sqlite3

logged = 0
c = ""
conn = ""

class SDK:
    def login(session):
        global start
        global logged
        global c
        global conn
        
        location = f"{session}.mpsession"
        table_name = "token"

        conn = sqlite3.connect(location)
        c = conn.cursor()

        conn.execute(f"CREATE TABLE IF NOT EXISTS token (token TEXT NOT NULL)")
        conn.commit()

        c.execute("SELECT * FROM token")
        try:
            token = c.fetchall()[0][0]
        except Exception:
            token = ""
        
        r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/GetMe").text)
        if not r['ok']:
            NewToken = ""
            while not r['ok'] == True:
                NewToken = input("Invalid token.\nInsert a new valid token: ")
                r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{NewToken}/GetMe").text)
            SDK.replaceToken(NewToken)

        if not logged:
            logged = 1
            print(f"Logged in as {r['result']['first_name']} {r['result']['last_name'] if r['result']['last_name'] else ''}")

    def getToken():
        c.execute("SELECT * FROM token")
        token = c.fetchall()[0][0]
        return token
    
    def replaceToken(token):
        c.execute("DELETE FROM token")
        c.execute("INSERT INTO token VALUES(?)", (token,))
        conn.commit()
    
    def createPoll(title=None,poll_type=1,privacy=1,choices=None,start_rating_range=None,end_rating_range=None,description="",settings=None):
        global logged
        if logged:
            token = SDK.getToken()
            poll_type = str(poll_type).lower()

            if not poll_type in ["rating","5"]:
                start_rating_range = None
                end_rating_range = None
            elif not poll_type in ["vote","1","doodle","2","limited doodle","3"]:
                choices = None
            
            try:
                if int(privacy) <= 1:
                    privacy = "anonymous"
                elif int(privacy) > 1:
                    privacy = "personal"
            except ValueError:
                pass
            
            poll = {
                    "title":title,
                    "type":poll_type,
                    "privacy":privacy,
                    "choices":choices if choices else None,
                    "start_rating_range":start_rating_range if start_rating_range else None,
                    "end_rating_range":end_rating_range if end_rating_range else None,
                    "description":description if description else None,
                    "settings":settings if settings else None
                    }
            url = (((f"title={title}")+(f"&type={poll_type}")+(f"&privacy={privacy}")+(f"&choices={choices}" if choices else "")+(f"&start_rating_range={start_rating_range}" if start_rating_range else "")+(f"&end_rating_range={end_rating_range}" if end_rating_range else "")+(f"&description={description}" if description else "")+(f"&settings=" if settings else ""))).replace(" ","").replace("'",'"').lower()
            r = requests.get(f"https://api.masterpoll.xyz/user{token}/createPoll?" + url).text
            return r
        
    def editPoll(poll_id, settings):
        global logged
        if logged:
            token = SDK.getToken()
            settings = str(settings).lower().replace(" ","").replace("'",'"')
            print(f"https://api.masterpoll.xyz/user{token}/editPoll?id={poll_id}&settings={settings}")
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/editPoll?id={poll_id}&settings={settings}").text)
            return r
        
    def deletePoll(poll_id):
        global logged
        if logged:
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/deletePoll?id={poll_id}").text)
            return r

    def getPoll(poll_id, owner_id=""):
        global logged
        if logged:
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/getPoll?id={poll_id}" + ("&owner_id={owner_id}" if owner_id else "")).text)
            return r

    def getActivePolls():
        global logged
        if logged:
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/getActivePolls").text)
            return r

    def getAllPolls():
        global logged
        if logged:
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/getAllPolls").text)

    def openPoll(poll_id):
        global logged
        if logged:
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/openPoll?id={poll_id}").text)
            return r

    def closePoll(poll_id):
        global logged
        if logged:
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/closePoll?id={poll_id}").text)
            return r

    def getMe():
        global logged
        if logged:
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/getMe").text)
            return r

    def graph(poll_id, graph_type="bar"):
        global logged
        if logged:
            try:
                if int(graph_type) <= 1:
                    graph_type = "bar"
                elif int(graph_type) > 1:
                    graph_type = "pie"
            except ValueError:
                pass
            token = SDK.getToken()
            r = json.loads(requests.get(f"https://api.masterpoll.xyz/user{token}/graph?id={poll_id}&type={graph_type}").text)
            return r
